<?php
//---------------------------------------------------------------------
// unto[lite] copyright(c)2024 cxx05610(zenmaido)
// 個人の範囲内で使用できますが、商用利用、再配布はご遠慮ください
//---------------------------------------------------------------------

//最小フロアサイズ(必ず奇数にすること)
$d_scale=5;
//全階層数 (1階上がる度にフロアのサイズがタテヨコ+2されるので巨大にしすぎないこと)
$d_floor=5;

//リーダーボードのデータファイル
$reader_dat='./data.dat';

//★debug
//1にすると全体マップと現在座標、フラグを表示
$debug=0;

//セッション・cookie有効期限(秒数で指定)
//セッションIDはcookieに保存されるので、cookieも同日数に設定
//60*60*24*保存したい日数
$ses_name='ul_session';
ini_set('session.gc_maxlifetime',60*60*24*30);
ini_set('session.cookie_lifetime',60*60*24*30);

//使用する変数をあらかじめ宣言(条件によってはエラーが出るため)
$main='';
$floor='';
$flag='';
$all_map='';

//HTML出力時のヘッダーとフッター
//通常画面とエンディング画面で使用するため、ヒアドキュメントで変数に入れておく
//本来なら別ファイルに作ってinclude_onceで読み込む方がスマートかも(cssも)
$header=<<<EOD
<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<title>unto[lite]</title>
<style type="text/css">
@import url('https://fonts.googleapis.com/css2?family=Silkscreen&display=swap');
*{margin:0px;padding:0px;font-size:16px;font-family:"Silkscreen",sans-serif;font-weight:400;font-style:normal;line-height:18px;}
html{}
@media screen and (max-width: 767px){html{width:100%;}}
body{background:#000;color:#0f0;margin:32px;}
h1{font-size:32px;font-weight:normal;line-height:32px;}
h2{font-size:16px;font-weight:normal; color:#f00;}
article{margin-bottom:16px;}
p{margin-bottom:16px;}
a{color:#0ff;}
li{margin-left:32px;}
input,button{color:#0f0;background:#000;border:1px solid #060;}
.dungeon td{width:32px;height:32px;margin:0px;padding:0px;text-align:center;font-size:32px;border:0px none;}
.red{color:#f00;}
.blu{color:#00f;}
.blink{animation: blinks 1s step-end infinite;}
@keyframes blinks{50%{opacity:0;}}
</style>
</head>
<body>
<header>
<h1>unto[lite]</h1>
<p>escape the dungeon unto light</p>
<p>--------------------------------</p>
</header>
<main>
<section>
<article>
EOD;

$footer=<<<EOD
</article>
</section>
</main>
<footer>
<p>--------------------------------</p>
&quot;unto[lite]&quot; (c)zenmaido 2024
</footer>
</body>
</html>
EOD;

session_start(); //セッションを使用する際は必ず先頭につける
if(empty($_SESSION[$ses_name])){ //セッションデータがなかったら下記を実行
	//startのリンクを作成し、$mainに入れておく
	$main='<p><a href="?act=start" class="blink">* start *</a></p></article>';
	//テキストファイル($reader_dat)に保存してあるリーダーボードのデータを$fileに読み込み、成形して$readerに入れる
	$reader='<ol>';
	$file=@file($reader_dat) or die('file open error');
	//foreachでデータの行数分、処理を繰り返し行う
	foreach($file as $var){
		//データはTSV形式(項目間をtabで区切る)なので、まずexplodeでtab(\t)で分割して配列$rankに入れる
		$rank=explode("\t",$var);
		//変数$readerの後ろに成形したテキストを付け足していく
		$reader.='<li>'.$rank[0].' sec: '.$rank[1].'</li>';
	}
	$reader.="</ol>\r\n";
}else{ //セッションが保存されていたら下記を実行
	//他のプレイヤーと共用しないデータはセッションに保存しているので
	//セッションから各データを読み込み
	$map	=$_SESSION[$ses_name]['map']; //マップデータ
	$coordx	=$_SESSION[$ses_name]['coordx']; //現在地のx座標
	$coordy	=$_SESSION[$ses_name]['coordy']; //同y座標
	$floor	=$_SESSION[$ses_name]['floor']; //現在地の階層
	$flag	=$_SESSION[$ses_name]['flag']; //所持品フラグ(松明、鳩or蜘蛛)
	$start	=$_SESSION[$ses_name]['start']; //開始時刻(ゴール時にこの数値を参照してタイムを算出)
	//現在地mと周囲(上下左右)のセル情報を取得 [※1]
	//データは数値で保存されており、それぞれ 0=wall 1=path 2～5=event
	$m=$map[$coordx][$coordy];
	$n=$map[$coordx][$coordy-1];
	$s=$map[$coordx][$coordy+1];
	$w=$map[$coordx-1][$coordy];
	$e=$map[$coordx+1][$coordy];

	//★debug
	//$debug=1の場合、全体マップを作製
	if($debug==1){
		$all_map="<table>";
		for($y=0;$y<(count($map));$y++){
			$all_map.="<tr>";
			for($x=0;$x<(count($map[$y]));$x++){
				$all_map.='<td style="border:1px solid;width:12px;height:12px;text-align:center;">'.$map[$x][$y].'</td>';
			}
			$all_map.="</tr>";
		}
		$all_map.="</table> x:$coordx y:$coordy flg:$flag";
	}

	//イベントのリンク設定
	$mm='.';
	if($m>=2 and $m<=5){ //通路・壁以外なら…
		$mm=array('-','.','t','v','*','z')[$m]; //イベントを表すアルファベット/記号に入れ替え
		if($mm=='t'){ //torch(1)の場合
			if($flag==1 or $flag==3 or $flag==5){ //フラグが1 or 3 or 5 なら
				$mm='<span class="red">'.$mm.'</span>'; //赤文字でクリックできないようにする
			}else{
				$mm='<a href="?act='.$mm.'">'.$mm.'</a>'; //1,3,5以外ならクリック可にする
			}
		}elseif($mm=='v'){ //dove(2)
			if($flag<=1){ //フラグが1以下なら鳩/蜘蛛は見つけていないのでクリック可
				$mm='<a href="?act='.$mm.'">'.$mm.'</a>';
			}else{
				$mm='<span class="red">'.$mm.'</span>';
			}
		}elseif($mm=='*'){ //spider(4)
			if($flag<=1){ //上と同じ理屈
				$mm='<a href="?act='.$mm.'">'.$mm.'</a>';
			}else{
				$mm='<span class="red">'.$mm.'</span>';
			}
		}elseif($mm=='z'){ //stair
			if($flag==3 or $flag==5){ //3か5なら松明と鳩/蜘蛛が揃っているのでクリック可にする
				$mm='<a href="?act='.$mm.'">'.$mm.'</a>';
			}else{
				$mm='<span class="red">'.$mm.'</span>';
			}
		}
		//※$flag(フラグ)について
		//何も持っていない場合、$flagを0とする
		//$flagに、松明をクリックしたら+1、鳩は+2、蜘蛛は+4 する
		//松明だけなら「1」、鳩だけなら「2」、蜘蛛だけなら「4」
		//松明+鳩なら「3」、松明+蜘蛛なら「5」となり、
		//これまでに何をクリックしたかが数値を見るだけで判別できる
	}
	
	//前述[※1]で取得した上下左右のデータから、外壁に通路or壁を作成 (0なら壁(-|)、1なら通路(+))
	if($n>0){
		$nn='<a href="?act=n">+</a>';
	}else{
		$nn='-';
	}
	if($s>0){
		$ss='<a href="?act=s">+</a>';
	}else{
		$ss='-';
	}
	if($w>0){
		$ww='<a href="?act=w">+</a>';
	}else{
		$ww='|';
	}
	if($e>0){
		$ee='<a href="?act=e">+</a>';
	}else{
		$ee='|';
	}

	//$mainに成形した部屋データを入れる
	//セッションデータがなければ最初に作ったstartのリンク、データがあれば部屋データが代入された状態となる
	$main=<<<EOD
<p>[ $floor F ]</p>
<table class="dungeon">
<tr><td>-</td><td>-</td><td>$nn</td><td>-</td><td>-</td></tr>
<tr><td>|</td><td>.</td><td>.</td><td>.</td><td>|</td></tr>
<tr><td>$ww</td><td>.</td><td>$mm</td><td>.</td><td>$ee</td></tr>
<tr><td>|</td><td>.</td><td>.</td><td>.</td><td>|</td></tr>
<tr><td>-</td><td>-</td><td>$ss</td><td>-</td><td>-</td></tr>
</table>
</article>
EOD;
}

//リンクをクリックした際の処理
//アドレスの後ろについている「http://～～?act=xxx」の「xxx」部分を取得する
$act='';
if(isset($_GET['act'])){
	//関数get_getを実行し、データの審査を行う
	//(8は「8文字以下」であることを指示)
	//データが適切でなければfalseを返され、$actは空になる
	$act=get_get('act',8); 
}

$f=0; //処理後にセッションを更新する(0)か否(1)かを判断するためのフラグ
if(mb_strlen($act)){ //$actにデータがある(審査を通り、文字数が1以上ある)ならば…
	//$actの中身がn(上移動),s(下移動),w(左移動),e(右移動),t(松明),v(鳩),*(蜘蛛),z(階段),reset(データ削除)ならば…
	//$nの中身が0(壁)でなければy座標を-1してセッションデータを更新、壁だったら何もしない($f=1)
	if($act=='n'){
		if($n>0){$coordy--;}else{$f=1;}
	}elseif($act=='s'){
		if($s>0){$coordy++;}else{$f=1;}
	}elseif($act=='w'){
		if($w>0){$coordx--;}else{$f=1;}
	}elseif($act=='e'){
		if($e>0){$coordx++;}else{$f=1;}
	//イベント処理 $flagの数値を見てアイテム未所持なら数値を足してセッション更新、既に持っていればエラー表示
	}elseif($act=='t'){
		if($flag==1 or $flag==3 or $flag==5){ // 1=torch / 3=torch+dove / 5=torch+spider
			$f=1;
			$err="already light a torch";
		}else{
			$flag+=1;
		}
	}elseif($act=='v'){ //dove
		if($flag<=1){ // 2=dove / 3=torch+dove / 5=torch+spider
			$flag+=2;
		}else{
			$f=1;
			$err='already find a dove or spider';
		}
	}elseif($act=='*'){ //spider
		if($flag<=1){ // 3=torch+dove / 4=spider / 5=torch+spider
			$flag+=4;
		}else{
			$f=1;
			$err='already find a dove or spide';
		}
	}elseif($act=='z'){ //stair
		//階段をクリックしたら、$floorから1引く
		$floor--;
		//ちゃんと上に上がる条件を満たしている(松明+鳩or蜘蛛)か確認
		if($flag==3 or $flag==5){
			$f=1;
			if($floor>0){
				//もし1階より下($floorが0より大きい)なら上階を作成して移動
				make_dungeon($floor);
				exit;
			}else{
				//1階から上った($floorが0)ならエンディング画面に遷移
				ending($ses_name);
			}
		}else{
			//条件を満たしていない場合、エラー表示
			$f=1;
			$err='you cannot up the stair';
		}
	}elseif($act=='reset'){
		//resetならセッション情報を削除
		//セッション処理用のフラグが「2」なのは、セッションを更新せずエラーメッセージも出さないため
		//（以下の処理で、0以下ならセッション更新、1ならエラーを出す）
		$f=2;
		del_session($ses_name);
		header('Location: '.'./index.php');
	}elseif($act=='start'){
		//start処理
		//最初の階の迷路を生成し、headerで表示を更新
		$f=2;
		make_dungeon($d_floor);
		header('Location: '.'./index.php');
	}
	if($f<=0){
		//セッションデータの更新
		//移動後の座標またはアイテムフラグを最新のものに入れ替える
		session_regenerate_id(true);
		$_SESSION[$ses_name]=array(
			'map'	=>$map,
			'coordx'=>$coordx,
			'coordy'=>$coordy,
			'floor'	=>$floor,
			'flag'	=>$flag,
			'start'	=>$start
		);
		header('Location: '.'./index.php');
	}else{
		//行動がNG($f=1)、かつエラー内容が設定されていない場合、とりあえずエラーメッセージを入れておく
		if($f==1 and !$err){
			$err="something error";
		}
	}
}

//フォームから名前が送信された場合、リーダーボードに登録する
if($_SERVER['REQUEST_METHOD']=='POST'){
	//関数get_postで送信されたデータ$nameの内容を審査
	$name=get_post('name',8);
	//現在時刻time()からスタート時刻を引くと、ゴールまでにかかった秒数が算出される
	$start=time()-$start;
	//送信されたのが半角英数字以外なら$nameを空にする
	if(!preg_match("/^[a-zA-Z0-9]+$/", $name)){$name=FALSE;}

	//$nameが審査を通っていれば、既存のデータに追加したうえで秒数順にソートする
	if($name){
		$reader=@file($reader_dat) or die('file open error');
		//ファイルから読み込んだデータ$readerに、array_unshiftで自分の記録を追加
		//"タイム[tab]名前[tab]x[改行]"
		//なお最後のxは改行記号の処理を省くために入れているだけ
		array_unshift($reader,"$start\t$name\tx\r\n");
		//$readerのデータをexplodeで分割し、配列$varに入れる
		$var=array();
		$i=0;
		foreach($reader as $read){
			$var[$i]=explode("\t",$read);
			$i++;
		}
		//array_columnで$varのキー[0]の値の配列を作成し、
		//array_multisortでSORT_ASC(昇順)に並べ替える
		array_multisort(array_column($var,0),SORT_ASC,$var);
		$i=0;
		foreach($var as $read){
			$reader[$i]=implode("\t",$read);
			$i++;
		}
		//データの行数が5以上の場合、array_sliceで0～5行だけを取り出して$readerに入れる
		if(count($reader)>5){
			$reader=array_slice($reader,0,5,true);
		}
		//ファイルに保存する
		file_put_contents($reader_dat,$reader,LOCK_EX);
	}
	//ここでゲームは終了なので、関数del_sessionでセッションを削除する
	del_session($ses_name);
	header('Location: '.'./index.php');
}

//functions-------------------------------------------------------------------------//
//エンディングを表示するための関数
function ending($var){
	global $header,$footer;
	echo <<<EOL
$header
<p class="red blink">* congratulations! *</p>
<p>you have escaped from<br />the deep dungeon!<br />so you are free (unlike us).</p>
</article>
<article>
<h2>[ readerboard ]</h2>
<form method="POST" action="?act=">
<input type=text name="name" placeholder="name(max 8 chars)" maxlength=8 size=16 pattern="^[0-9A-Za-z]+$" required>
<button type="submit">enter</button>
</article>
<article>
<p><a href="./?act=reset">* back *</a></p>
$footer
EOL;
	exit;
}

//getで得たデータの審査
function get_get($key,$len){
	$var=trim($_GET[$key]); //データ内の改行記号を削除
	if(mb_strlen($var)<=0 or mb_strlen($var)>$len){ //文字数が0または$len以上ならfalseを返す
		return FALSE;
	}else{
		$var=htmlspecialchars($var,ENT_QUOTES,'UTF-8'); //よからぬ記号(<>"'&)を変換
		$var=str_replace(',','&comma;',$var); //念のためコンマも変換
		$var=nl2br($var); //改行記号を<BR />に変換
		$var=str_replace(array("\r\n", "\r", "\n"), "", $var); //残った改行記号を削除
		return $var;
	}
}

//postで得たデータの審査
function get_post($key,$length){ //上に同じ
	$var=trim($_POST[$key]);
	if(mb_strlen($var)<=0 or mb_strlen($var)>$length){
		return FALSE;
	}else{
		$var=htmlspecialchars($var,ENT_QUOTES,'UTF-8');
		$var=str_replace(',','&comma;',$var);
		$var=nl2br($var);
		$var=str_replace(array("\r\n", "\r", "\n"), "", $var);
		return $var;
	}
}

//セッションの削除
function del_session($var){
	$_SESSION=array(); //セッション変数を削除
	if(isset($_COOKIE[$var])){
		setcookie($var,'',time()-3600); //cookieも削除
	}
	session_destroy(); //セッションデータをﾃﾞｽﾄﾛｰｲ
}

//ダンジョン自動生成
//本編はあみだくじ方式でしたが今回は「棒倒し法」を採用
//▼アルゴリズムはこちらの記事を参考にしました
//https://algoful.com/Archive/Algorithm/MazeBar
function make_dungeon($var){
	// $var:階層
	global $ses_name,$d_scale,$d_floor;
	$wall=0; //壁は0
	$path=1; //通路は1
	if($var>$d_floor){$var=$d_floor;} //最小サイズより小さな値が来たら初期値にする
	$scale=$d_scale+(($d_floor-$var)*2); //(最大フロア-現在のフロア)*2をフロアサイズ初期値に足す(1階毎に+2)
	if($scale%2==0){$scale++;} //偶数が来たら奇数にする
	$map=array();
	//フロアサイズ回繰り返す
	for($x=0;$x<$scale;$x++){
		for($y=0;$y<$scale;$y++){ //外周を作成(周囲を全て壁にする)
			if($x==0 or $y==0 or $x==$scale-1 or $y==$scale-1){
				$map[$x][$y]=$wall; //壁
			}else{
				$map[$x][$y]=$path; //道
			}
		}
	}
	for($x=2;$x<$scale-1;$x+=2){ //棒倒し
		for($y=2;$y<$scale-1;$y+=2){
			$map[$x][$y]=$wall; //棒を立てる
			for($i=0;$i<=99;$i++){ //100周するかbreakでループを抜けるまで繰り返す
				$wx=$x;
				$wy=$y;
				if($y==2){ //1行目なら…
					$dir=mt_rand(0,3); //0～3の4方向から抽選(3が出たら上に倒せる)
				}else{ //2行目以降なら…
					$dir=mt_rand(0,2); //0～2の3方向から抽選(2までしか出ないので上に倒せない)
				}
				if($dir==0){ //右
					$wx++;
					break;
				}elseif($dir==1){ //下
					$wy++;
					break;
				}elseif($dir==2){ //左
					$wx--;
					break;
				}else{ //上
					$wy--;
					break;
				}
			}
			//倒す方向に壁を作る
			$map[$wx][$wy]=$wall;
		}
	}
	for($i=2;$i<=6;$i++){ //イベント設置
		for($j=0;$j<=99;$j++){ //100回までは試行する
			$rndx=mt_rand(1,$scale-1);
			$rndy=mt_rand(1,$scale-1);
			if($map[$rndx][$rndy]==$path){ //ランダムで選んだ座標が通路(1)であれば
				//$iが6より小さいうちは、選んだ座標にイベント(2～5)を設置
				//6以上の場合は何もせずループを抜ける(座標だけは取得) [※2]
				if($i<6){
					$map[$rndx][$rndy]=$i;
				}
				break;
			}
		}
	}
	// セッション更新
	session_regenerate_id(true);
	$_SESSION[$ses_name]=array(
		'map'	=>$map,
		'coordx'=>$rndx, //[※2]で作成した座標がスポーン地点として使用される
		'coordy'=>$rndy,
		'floor'	=>$var,
		'flag'	=>0,
		'start'	=>time()
	);
	header('Location: '.'./index.php');
}

// 以下、HTMLの出力-------------------------------------------------------------------------
//ヘッダー出力
echo $header;

//エラーメッセージがあれば出力
if(!empty($err)){
	echo '<p class="red blink">* '.$err.' *</p>';
}
//$main(startリンクあるいは部屋)の出力
echo $main;

//デバッグが有効の場合、全体マップを出力
if($all_map){
	echo $all_map;
}
//ここで一旦phpの記述を終了
//php外のhtmlはそのまま出力される
?>

<article>
<h2>[ rule ]</h2>
<p>light a torch(t),<br />find dove(v) or spider(*),<br />and go up the stair(z).</p>
<p>+ : path<br />- | : wall<br />. : floor</p>
</article>

<?php
//再びphpの記述を開始
//セッションデータがあればresetのリンク、なければリーダーボードを表示
if(!empty($_SESSION[$ses_name])){
	echo <<<EOL
<article>
<h2>[ reset ]</h2>
<p><a href="?act=reset">reset all data</a></p>
EOL;
}else{
	echo <<<EOL
<article>
<h2>[ readerboard ]</h2>
$reader
EOL;
}

//htmlのフッターを出力して終了
echo $footer;
exit;
?>
